## hmake 3.08

=== Makefile ===
MACHINE := $(shell script/harch)
export MACHINE

# This included config is only for the BUILDWITH variable.
include targets/$(MACHINE)/config.cache
BUILDCOMP = $(shell echo ${BUILDWITH} | cut -c1-3)

HMAKE = src/hmake/Makefile* src/hmake/*.hs src/hmake/README* \
	src/hmake/HISTORY src/hmake/Summary* \
	src/interpreter/Makefile* src/interpreter/*.hs

LIBDIR  = lib
TARGDIR = targets
TARGETS = hmake-nhc hmake-hbc hmake-ghc chmake hi-nhc hi-hbc hi-ghc chi


##### compiler build + install scripts

all:   all-${BUILDCOMP}
hmake: hmake-${BUILDCOMP}
hi:    hi-${BUILDCOMP}
help:
	@echo "Common targets include:        all install clean realclean config"
	@echo "Common targets include:        hmake hi"
	@echo "For a specific build-compiler: all-hbc  all-ghc  all-nhc98 all-gcc"

config:
	./configure --config
install: all
	./configure --install

all-hbc: hmake-hbc hi-hbc
all-ghc: hmake-ghc hi-ghc
all-gcc: chmake chi
all-nhc: hmake-nhc hi-nhc


$(TARGETS): % : $(TARGDIR)/$(MACHINE)/%


$(TARGDIR)/$(MACHINE)/hmake-nhc: $(HMAKE)
	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) install config
	touch $(TARGDIR)/$(MACHINE)/hmake-nhc
$(TARGDIR)/$(MACHINE)/hmake-hbc: $(HMAKE)
	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) install config
	touch $(TARGDIR)/$(MACHINE)/hmake-hbc
$(TARGDIR)/$(MACHINE)/hmake-ghc: $(HMAKE)
	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) install config
	touch $(TARGDIR)/$(MACHINE)/hmake-ghc
$(TARGDIR)/$(MACHINE)/chmake: $(HMAKEC)
	@echo "WARNING: hmake might not build correctly from C sources!"
	cd src/hmake;          $(MAKE) HC=nhc98 fromC config
	touch $(TARGDIR)/$(MACHINE)/chmake

$(TARGDIR)/$(MACHINE)/hi-nhc: $(HMAKE) hmake-nhc
	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) install
	touch $(TARGDIR)/$(MACHINE)/hi-nhc98
$(TARGDIR)/$(MACHINE)/hi-hbc: $(HMAKE) hmake-hbc
	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) install
	touch $(TARGDIR)/$(MACHINE)/hi-hbc
$(TARGDIR)/$(MACHINE)/hi-ghc: $(HMAKE) hmake-ghc
	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) install
	touch $(TARGDIR)/$(MACHINE)/hi-ghc
$(TARGDIR)/$(MACHINE)/chi: $(HMAKEC) chmake
	@echo "WARNING: hi might not build correctly from C sources!"
	cd src/interpreter;    $(MAKE) HC=nhc98 fromC
	touch $(TARGDIR)/$(MACHINE)/chi


##### cleanup

clean:
	cd src/hmake;          $(MAKE) clean
	cd src/interpreter;    $(MAKE) clean

realclean: clean
	cd $(TARGDIR)/$(MACHINE);  rm -f $(TARGETS)
	cd $(TARGDIR);  rm -f hmakeC
	rm -f $(LIBDIR)/$(MACHINE)/*
	rm -f $(TARGDIR)/$(MACHINE)/config.cache
	rm -f $(LIBDIR)/$(MACHINE)/hmakerc
	rm -f script/hmake script/hi script/hmake-config

=== src/interpreter/Makefile ===
include Makefile.inc

OBJDIR = ${BUILDDIR}/obj/interpreter
TARGET = ${DST}/HInteractive$(EXE)

SRCS   = HInteractive.hs HiConfig.hs SimpleLineEditor.hs LexModule.hs
OTHERS = Unlit.hs Compiler.hs Config.hs	Platform.hs # from src/hmake

CHFILES = $(patsubst %.hs, ../hmake/%.$C, $(OTHERS))


ifeq "$(findstring ghc, ${HC})" "ghc"
HFLAGS = $(shell $(LOCAL)fixghc $(GHCSYM) \
                 -package lang -package util -package base $(READLINE) )
export HFLAGS
endif
ifeq "$(findstring hbc, ${HC})" "hbc"
HFLAGS =
export HFLAGS
endif
ifeq "$(findstring nhc98, ${HC})" "nhc98"
HFLAGS = -package base
export HFLAGS
endif

all: $(TARGET)
install: $(TARGET)
cfiles: $(SRCS)
	-rm -f *.hi *.hc
	$(HMAKE) -hc=$(LOCAL)nhc98 -I../hmake -package base -C HInteractive.hs
clean:
	-rm -f *.hi *.o $(OBJDIR)/*.o $(OBJDIR)/HInteractive$(EXE)
realclean: clean
	-rm -f *.hc *.c

$(TARGET): $(OBJDIR) $(SRCS)
	$(HMAKE) -hc=$(HC) HInteractive -d$(OBJDIR) \
		$(shell echo "${BUILDOPTS}") -i../hmake $(HFLAGS)
	mv $(OBJDIR)/HInteractive$(EXE) $(TARGET)
	strip $(TARGET)

$(OBJDIR):
	mkdir -p $(OBJDIR)

fromC: $(OBJDIR)
	cp $(CHFILES) .
	$(LOCAL)nhc98 -cpp -o $(TARGET) -d$(OBJDIR) *.$C
	strip $(TARGET)


paper.ps: paper.dvi
	#dvips paper.dvi -O -1.0cm,-2.6cm -o paper.ps
	dvips paper.dvi -o paper.ps
paper.dvi: paper.tex
	latex paper.tex

## hmake 3.09

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,8 @@
 
 HMAKE = src/hmake/Makefile* src/hmake/*.hs src/hmake/README* \
 	src/hmake/HISTORY src/hmake/Summary* \
-	src/interpreter/Makefile* src/interpreter/*.hs
+	src/interpreter/Makefile* src/interpreter/*.hs \
+	src/cpphs/*.hs
 
 LIBDIR  = lib
 TARGDIR = targets
@@ -39,13 +40,13 @@
 
 
 $(TARGDIR)/$(MACHINE)/hmake-nhc: $(HMAKE)
-	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) install config
+	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) all config
 	touch $(TARGDIR)/$(MACHINE)/hmake-nhc
 $(TARGDIR)/$(MACHINE)/hmake-hbc: $(HMAKE)
-	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) install config
+	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) all config
 	touch $(TARGDIR)/$(MACHINE)/hmake-hbc
 $(TARGDIR)/$(MACHINE)/hmake-ghc: $(HMAKE)
-	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) install config
+	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) all config
 	touch $(TARGDIR)/$(MACHINE)/hmake-ghc
 $(TARGDIR)/$(MACHINE)/chmake: $(HMAKEC)
 	@echo "WARNING: hmake might not build correctly from C sources!"
@@ -53,13 +54,13 @@
 	touch $(TARGDIR)/$(MACHINE)/chmake
 
 $(TARGDIR)/$(MACHINE)/hi-nhc: $(HMAKE) hmake-nhc
-	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) install
+	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) all
 	touch $(TARGDIR)/$(MACHINE)/hi-nhc98
 $(TARGDIR)/$(MACHINE)/hi-hbc: $(HMAKE) hmake-hbc
-	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) install
+	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) all
 	touch $(TARGDIR)/$(MACHINE)/hi-hbc
 $(TARGDIR)/$(MACHINE)/hi-ghc: $(HMAKE) hmake-ghc
-	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) install
+	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) all
 	touch $(TARGDIR)/$(MACHINE)/hi-ghc
 $(TARGDIR)/$(MACHINE)/chi: $(HMAKEC) chmake
 	@echo "WARNING: hi might not build correctly from C sources!"

=== src/hmake/Makefile ===
include Makefile.inc

OBJDIR   = $(BUILDDIR)/$(OBJ)/hmake
MKPROG   = $(DST)/MkProg$(EXE)
OLDER    = $(DST)/Older$(EXE)
MKCONFIG = $(DST)/MkConfig$(EXE)
TARGETS  = $(MKPROG) $(OLDER) $(MKCONFIG)

SRCS    = QSort.hs Unlit.hs Utils.hs Tsort.hs FileName.hs \
	  Output.hs Order.hs ListUtil.hs Getmodtime.hs \
          MkProg.hs IsPrefixOf.hs Compiler.hs PreProcessor.hs \
	  PackageConfig.hs Config.hs RunAndReadStdout.hs
CPPHSSRCS  = CppIfdef.hs ParseLib.hs Position.hs ReadFirst.hs Tokenise.hs \
	     SymTab.hs HashDefine.hs
CPPSRCS = Argv.hs Graph.hs GetDep.hs Compat.hs Imports.hs \
	  Platform.hs
CFGSRCS = RunAndReadStdout.hs Config.hs Compiler.hs Platform.hs
 

OBJS    = $(patsubst %.hs, $(OBJDIR)/%.$O, $(SRCS) $(CPPHSSRCS))
CPPOBJS = $(patsubst %.hs, $(OBJDIR)/%.$O, $(CPPSRCS))
RAWCPP  = $(patsubst %.hs, %.raw, $(SRCS))
CFGOBJS = $(patsubst %.hs, $(OBJDIR)/%.$O, $(CFGSRCS))
CFILES    = $(patsubst %.hs, %.$C, $(SRCS) $(CPPHSSRCS))
CPPCFILES = $(patsubst %.hs, %.$C, $(CPPSRCS))
CFGCFILES = $(patsubst %.hs, %.$C, $(CFGSRCS))

AUX     = Makefile* BuildNew* HISTORY README* Summary TODO nhcmakeR cfiles \
          hmake hmake.1

HC = $(LOCAL)nhc98	# can be overridden by caller HC=...
HFLAGS = $(shell echo $(BUILDOPTS)) #-$(CFG)

ifeq "nhc98" "$(findstring nhc98, ${HC})"
HEAP = -H4M
endif
ifeq "ghc" "$(findstring ghc, ${HC})"
HFLAGS += $(shell ${LOCAL}fixghc ${GHCSYM} -package lang)
endif
ifeq "hbc" "$(findstring hbc, ${HC})"
hbc: CppIfdef.hs
	sed -e 's/System.IO.Unsafe/IOExts/' CppIfdef.hs >hbc
	cp -a hbc CppIfdef.hs
all: hbc
endif


all: $(TARGETS)
config:
	sh $(BUILDDIR)/hmake3.config
cfiles: cleanC $(CFILES) $(CPPCFILES) Older.$C MkConfig.$C
fromC: $(OBJDIR)
	$(HC) $(HFLAGS) -H4M -o $(MKPROG) -d $(OBJDIR) $(CFILES) $(CPPCFILES)
	$(HC) $(HFLAGS)      -o $(OLDER)  -d $(OBJDIR) Older.$C
	$(HC) $(HFLAGS)    -o $(MKCONFIG) -d $(OBJDIR) MkConfig.$C $(CFGCFILES)
	$(STRIP) $(MKPROG) $(OLDER) $(MKCONFIG)
clean:
	rm -f $(OBJS) $(CPPOBJS) $(OBJDIR)/Older.$O $(OBJDIR)/MkConfig.$O
	rm -f *.hi
cleanC: clean
	rm -f *.hc *.c
realclean: cleanC
	rm -f *.raw *.html haddock.css haskell_icon.gif
	rm -f $(TARGETS)
#package:
#	tar zcvf hmake.tar.gz $(SRCS) $(GCSRCS) $(CPPSRCS) Older.hs MkConfig.hs $(AUX)
haddock: $(RAWCPP)
	haddock -h *.raw
	rm *.raw


$(MKPROG): $(OBJDIR) $(OBJS) $(CPPOBJS)
	$(HC) $(HFLAGS) $(HEAP) -o $@  $(OBJS) $(CPPOBJS)
	$(STRIP) $@
$(OLDER): $(OBJDIR) $(OBJDIR)/Older.$O
	$(HC) $(HFLAGS) -o $@  $(OBJDIR)/Older.$O
	$(STRIP) $@
$(MKCONFIG): $(OBJDIR) $(OBJDIR)/MkConfig.$O $(CFGOBJS)
	$(HC) $(HFLAGS) -o $@  $(OBJDIR)/MkConfig.$O $(CFGOBJS)
	$(STRIP) $@

%.raw:
	cpp -P -traditional $(patsubst %.raw, %.hs, $@) > $@

$(OBJDIR):
	mkdir -p $(OBJDIR) || $(TRUE)
$(OBJS): $(OBJDIR)/%.$O : %.hs
	$(HC) $(HFLAGS) -c -o $@ $<
$(CPPOBJS) $(OBJDIR)/Older.$O $(OBJDIR)/MkConfig.$O: $(OBJDIR)/%.$O : %.hs
	$(HC) $(HFLAGS) -c -cpp -o $@ $<

$(CFILES): %.$C : %.hs
	$(HC) $(HFLAGS) -C $<
$(CPPCFILES) Older.$C MkConfig.$C: %.$C : %.hs
	$(HC) $(HFLAGS) -C -cpp $<

# copy some necessary files from cpphs to here.
$(CPPHSSRCS): % : ../cpphs/%
	cp ../cpphs/$@ .

# dependencies generated by hmake -Md:
${OBJDIR}/Output.$O:	${OBJDIR}/ListUtil.$O ${OBJDIR}/FileName.$O \
			${OBJDIR}/Argv.$O ${OBJDIR}/PreProcessor.$O \
			${OBJDIR}/Config.$O ${OBJDIR}/RunAndReadStdout.$O
${OBJDIR}/Utils.$O:	${OBJDIR}/Compat.$O ${OBJDIR}/ListUtil.$O 
${OBJDIR}/Tsort.$O:	${OBJDIR}/Compat.$O 
${OBJDIR}/Graph.$O:	${OBJDIR}/Compat.$O ${OBJDIR}/ListUtil.$O 
${OBJDIR}/QSort.$O:	
${OBJDIR}/Compat.$O:	${OBJDIR}/ListUtil.$O ${OBJDIR}/QSort.$O 
${OBJDIR}/Order.$O:	${OBJDIR}/Compat.$O ${OBJDIR}/Graph.$O \
			${OBJDIR}/ListUtil.$O ${OBJDIR}/Tsort.$O \
			${OBJDIR}/Utils.$O 
${OBJDIR}/PreProcessor.$O: ${OBJDIR}/Argv.$O ${OBJDIR}/Compiler.$O \
			${OBJDIR}/Config.$O ${OBJDIR}/Unlit.$O 
${OBJDIR}/Unlit.$O:	
${OBJDIR}/FileName.$O:	${OBJDIR}/Argv.$O 
${OBJDIR}/HashDefine.$O:
${OBJDIR}/Tokenise.$O:	${OBJDIR}/HashDefine.$O
${OBJDIR}/ReadFirst.$O:	${OBJDIR}/Position.$O ${OBJDIR}/SymTab.$O
${OBJDIR}/Position.$O:	
${OBJDIR}/ParseLib.$O:	
${OBJDIR}/SymTab.$O:	
${OBJDIR}/CppIfdef.$O:	${OBJDIR}/SymTab.$O ${OBJDIR}/ParseLib.$O \
			${OBJDIR}/Position.$O ${OBJDIR}/ReadFirst.$O \
			${OBJDIR}/Tokenise.$O
${OBJDIR}/Imports.$O:	${OBJDIR}/ListUtil.$O ${OBJDIR}/CppIfdef.$O
${OBJDIR}/Getmodtime.$O: 
${OBJDIR}/GetDep.$O:	${OBJDIR}/Getmodtime.$O ${OBJDIR}/Imports.$O \
			${OBJDIR}/FileName.$O ${OBJDIR}/Unlit.$O \
			${OBJDIR}/Argv.$O ${OBJDIR}/PreProcessor.$O \
			${OBJDIR}/Config.$O 
${OBJDIR}/RunAndReadStdout.$O:	${OBJDIR}/Platform.$O
${OBJDIR}/PackageConfig.$O:	${OBJDIR}/Config.$O ${OBJDIR}/Compiler.$O \
			${OBJDIR}/Platform.$O ${OBJDIR}/RunAndReadStdout.$O 
${OBJDIR}/Platform.$O:	
${OBJDIR}/Config.$O:	${OBJDIR}/Compiler.$O ${OBJDIR}/Platform.$O
${OBJDIR}/Compiler.$O:	
${OBJDIR}/ListUtil.$O:	
${OBJDIR}/Argv.$O:	${OBJDIR}/ListUtil.$O ${OBJDIR}/Compiler.$O \
			${OBJDIR}/Config.$O ${OBJDIR}/PackageConfig.$O \
			${OBJDIR}/Platform.$O
${OBJDIR}/MkProg.$O:	${OBJDIR}/Argv.$O ${OBJDIR}/GetDep.$O \
			${OBJDIR}/Getmodtime.$O ${OBJDIR}/ListUtil.$O \
			${OBJDIR}/Order.$O ${OBJDIR}/Output.$O 
${OBJDIR}/MkConfig.$O:	${OBJDIR}/Compiler.$O ${OBJDIR}/Config.$O \
			${OBJDIR}/Platform.$O
${OBJDIR}/Older.$O:	

ifeq "hbc" "$(HC)"
${OBJDIR}/Argv.$O:	${OBJDIR}/IsPrefixOf.$O
endif


# C-files dependencies.
MkConfig.$C: Compiler.$C Config.$C Platform.$C RunAndReadStdout.$C 
Output.$C: ListUtil.$C FileName.$C Argv.$C PreProcessor.$C Config.$C \
	RunAndReadStdout.$C 
Utils.$C: Compat.$C ListUtil.$C 
Tsort.$C: Compat.$C 
Graph.$C: Compat.$C ListUtil.$C 
QSort.$C: 
Compat.$C: ListUtil.$C QSort.$C 
Order.$C: Compat.$C Graph.$C ListUtil.$C Tsort.$C Utils.$C 
PreProcessor.$C: Argv.$C Compiler.$C Config.$C Unlit.$C 
Unlit.$C: 
FileName.$C: Argv.$C 
HashDefine.$C: 
Tokenise.$C: HashDefine.$C 
ReadFirst.$C: Position.$C SymTab.$C 
Position.$C: 
ParseLib.$C: 
SymTab.$C: 
CppIfdef.$C: SymTab.$C ParseLib.$C Position.$C ReadFirst.$C Tokenise.$C 
Imports.$C: ListUtil.$C CppIfdef.$C 
Getmodtime.$C: 
GetDep.$C: Getmodtime.$C Imports.$C FileName.$C Unlit.$C Argv.$C \
	PreProcessor.$C Config.$C 
RunAndReadStdout.$C: Platform.$C 
PackageConfig.$C: Config.$C Compiler.$C Platform.$C RunAndReadStdout.$C 
Platform.$C: 
Config.$C: Compiler.$C Platform.$C 
Compiler.$C: 
ListUtil.$C: 
Argv.$C: ListUtil.$C Compiler.$C Config.$C PackageConfig.$C Platform.$C 
MkProg.$C: Argv.$C GetDep.$C Getmodtime.$C ListUtil.$C Order.$C Output.$C

=== src/interpreter/Makefile ===
--- 
+++ 
@@ -24,20 +24,20 @@
 endif
 
 all: $(TARGET)
-install: $(TARGET)
-cfiles: $(SRCS)
-	-rm -f *.hi *.hc
+cfiles: cleanC $(SRCS)
 	$(HMAKE) -hc=$(LOCAL)nhc98 -I../hmake -package base -C HInteractive.hs
 clean:
-	-rm -f *.hi *.o $(OBJDIR)/*.o $(OBJDIR)/HInteractive$(EXE)
-realclean: clean
+	-rm -f *.hi *.o $(OBJDIR)/*.o
+cleanC: clean
 	-rm -f *.hc *.c
+realclean: clean cleanC
+	-rm -f $(OBJDIR)/HInteractive$(EXE)
 
 $(TARGET): $(OBJDIR) $(SRCS)
 	$(HMAKE) -hc=$(HC) HInteractive -d$(OBJDIR) \
 		$(shell echo "${BUILDOPTS}") -i../hmake $(HFLAGS)
 	mv $(OBJDIR)/HInteractive$(EXE) $(TARGET)
-	strip $(TARGET)
+	$(STRIP) $(TARGET)
 
 $(OBJDIR):
 	mkdir -p $(OBJDIR)
@@ -45,7 +45,7 @@
 fromC: $(OBJDIR)
 	cp $(CHFILES) .
 	$(LOCAL)nhc98 -cpp -o $(TARGET) -d$(OBJDIR) *.$C
-	strip $(TARGET)
+	$(STRIP) $(TARGET)
 
 
 paper.ps: paper.dvi

## hmake 3.10

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,12 @@
 
 # This included config is only for the BUILDWITH variable.
 include targets/$(MACHINE)/config.cache
-BUILDCOMP = $(shell echo ${BUILDWITH} | cut -c1-3)
+#BUILDCOMP = $(shell echo ${BUILDWITH} | cut -c1-3)
+BUILDCOMPS := ghc nhc hbc gcc
+BUILDCOMP1 := $(shell echo $(notdir ${BUILDWITH}) | cut -c1-3)
+BUILDCOMP2 := $(if $(filter $(BUILDCOMP1), $(BUILDCOMPS)),$(BUILDCOMP1),$(shell ${BUILDWITH} 2>&1 | head -1 | cut -c1-3))
+BUILDCOMP := $(if $(filter $(BUILDCOMP2), $(BUILDCOMPS)),$(BUILDCOMP2),$(error Can't find compiler type))
+
 
 HMAKE = src/hmake/Makefile* src/hmake/*.hs src/hmake/README* \
 	src/hmake/HISTORY src/hmake/Summary* \
@@ -40,31 +45,31 @@
 
 
 $(TARGDIR)/$(MACHINE)/hmake-nhc: $(HMAKE)
-	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) all config
+	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) BUILDCOMP=$(BUILDCOMP) all config
 	touch $(TARGDIR)/$(MACHINE)/hmake-nhc
 $(TARGDIR)/$(MACHINE)/hmake-hbc: $(HMAKE)
-	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) all config
+	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) BUILDCOMP=$(BUILDCOMP) all config
 	touch $(TARGDIR)/$(MACHINE)/hmake-hbc
 $(TARGDIR)/$(MACHINE)/hmake-ghc: $(HMAKE)
-	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) all config
+	cd src/hmake;          $(MAKE) HC=$(BUILDWITH) BUILDCOMP=$(BUILDCOMP) all config
 	touch $(TARGDIR)/$(MACHINE)/hmake-ghc
 $(TARGDIR)/$(MACHINE)/chmake: $(HMAKEC)
 	@echo "WARNING: hmake might not build correctly from C sources!"
-	cd src/hmake;          $(MAKE) HC=nhc98 fromC config
+	cd src/hmake;          $(MAKE) HC=nhc98 BUILDCOMP=$(BUILDCOMP) fromC config
 	touch $(TARGDIR)/$(MACHINE)/chmake
 
 $(TARGDIR)/$(MACHINE)/hi-nhc: $(HMAKE) hmake-nhc
-	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) all
+	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) BUILDCOMP=$(BUILDCOMP) all
 	touch $(TARGDIR)/$(MACHINE)/hi-nhc98
 $(TARGDIR)/$(MACHINE)/hi-hbc: $(HMAKE) hmake-hbc
-	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) all
+	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) BUILDCOMP=$(BUILDCOMP) all
 	touch $(TARGDIR)/$(MACHINE)/hi-hbc
 $(TARGDIR)/$(MACHINE)/hi-ghc: $(HMAKE) hmake-ghc
-	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) all
+	cd src/interpreter;    $(MAKE) HC=$(BUILDWITH) BUILDCOMP=$(BUILDCOMP) all
 	touch $(TARGDIR)/$(MACHINE)/hi-ghc
 $(TARGDIR)/$(MACHINE)/chi: $(HMAKEC) chmake
 	@echo "WARNING: hi might not build correctly from C sources!"
-	cd src/interpreter;    $(MAKE) HC=nhc98 fromC
+	cd src/interpreter;    $(MAKE) HC=nhc98 BUILDCOMP=$(BUILDCOMP) fromC
 	touch $(TARGDIR)/$(MACHINE)/chi

=== src/hmake/Makefile ===
--- 
+++ 
@@ -8,12 +8,11 @@
 
 SRCS    = QSort.hs Unlit.hs Utils.hs Tsort.hs FileName.hs \
 	  Output.hs Order.hs ListUtil.hs Getmodtime.hs \
-          MkProg.hs IsPrefixOf.hs Compiler.hs PreProcessor.hs \
-	  PackageConfig.hs Config.hs RunAndReadStdout.hs
+          MkProg.hs Compiler.hs PreProcessor.hs \
+	  PackageConfig.hs RunAndReadStdout.hs Argv.hs
 CPPHSSRCS  = CppIfdef.hs ParseLib.hs Position.hs ReadFirst.hs Tokenise.hs \
 	     SymTab.hs HashDefine.hs
-CPPSRCS = Argv.hs Graph.hs GetDep.hs Compat.hs Imports.hs \
-	  Platform.hs
+CPPSRCS = Graph.hs GetDep.hs Compat.hs Imports.hs Platform.hs Config.hs
 CFGSRCS = RunAndReadStdout.hs Config.hs Compiler.hs Platform.hs
  
 
@@ -29,15 +28,16 @@
           hmake hmake.1
 
 HC = $(LOCAL)nhc98	# can be overridden by caller HC=...
+BUILDCOMP = nhc		# override this too if you override HC
 HFLAGS = $(shell echo $(BUILDOPTS)) #-$(CFG)
 
-ifeq "nhc98" "$(findstring nhc98, ${HC})"
+ifeq "nhc" "$(BUILDCOMP)"
 HEAP = -H4M
 endif
-ifeq "ghc" "$(findstring ghc, ${HC})"
+ifeq "ghc" "$(BUILDCOMP)"
 HFLAGS += $(shell ${LOCAL}fixghc ${GHCSYM} -package lang)
 endif
-ifeq "hbc" "$(findstring hbc, ${HC})"
+ifeq "hbc" "$(BUILDCOMP)"
 hbc: CppIfdef.hs
 	sed -e 's/System.IO.Unsafe/IOExts/' CppIfdef.hs >hbc
 	cp -a hbc CppIfdef.hs
@@ -133,7 +133,8 @@
 ${OBJDIR}/PackageConfig.$O:	${OBJDIR}/Config.$O ${OBJDIR}/Compiler.$O \
 			${OBJDIR}/Platform.$O ${OBJDIR}/RunAndReadStdout.$O 
 ${OBJDIR}/Platform.$O:	
-${OBJDIR}/Config.$O:	${OBJDIR}/Compiler.$O ${OBJDIR}/Platform.$O
+${OBJDIR}/Config.$O:	${OBJDIR}/Compiler.$O ${OBJDIR}/Platform.$O \
+			${OBJDIR}/RunAndReadStdout.$O 
 ${OBJDIR}/Compiler.$O:	
 ${OBJDIR}/ListUtil.$O:	
 ${OBJDIR}/Argv.$O:	${OBJDIR}/ListUtil.$O ${OBJDIR}/Compiler.$O \
@@ -142,17 +143,13 @@
 ${OBJDIR}/MkProg.$O:	${OBJDIR}/Argv.$O ${OBJDIR}/GetDep.$O \
 			${OBJDIR}/Getmodtime.$O ${OBJDIR}/ListUtil.$O \
 			${OBJDIR}/Order.$O ${OBJDIR}/Output.$O 
-${OBJDIR}/MkConfig.$O:	${OBJDIR}/Compiler.$O ${OBJDIR}/Config.$O \
-			${OBJDIR}/Platform.$O
+${OBJDIR}/MkConfig.$O:	${OBJDIR}/Compiler.$O ${OBJDIR}/Config.$O
 ${OBJDIR}/Older.$O:	
 
-ifeq "hbc" "$(HC)"
-${OBJDIR}/Argv.$O:	${OBJDIR}/IsPrefixOf.$O
-endif
 
 
 # C-files dependencies.
-MkConfig.$C: Compiler.$C Config.$C Platform.$C RunAndReadStdout.$C 
+MkConfig.$C: Compiler.$C Config.$C
 Output.$C: ListUtil.$C FileName.$C Argv.$C PreProcessor.$C Config.$C \
 	RunAndReadStdout.$C 
 Utils.$C: Compat.$C ListUtil.$C 
@@ -178,7 +175,7 @@
 RunAndReadStdout.$C: Platform.$C 
 PackageConfig.$C: Config.$C Compiler.$C Platform.$C RunAndReadStdout.$C 
 Platform.$C: 
-Config.$C: Compiler.$C Platform.$C 
+Config.$C: Compiler.$C Platform.$C RunAndReadStdout.$C
 Compiler.$C: 
 ListUtil.$C: 
 Argv.$C: ListUtil.$C Compiler.$C Config.$C PackageConfig.$C Platform.$C

## hmake 3.12

=== src/interpreter/Makefile ===
include Makefile.inc

OBJDIR = ${BUILDDIR}/obj/interpreter
TARGET = ${DST}/HInteractive$(EXE)

SRCS   = HInteractive.hs HiConfig.hs SimpleLineEditor.hs LexModule.hs
OTHERS = Unlit.hs Compiler.hs Config.hs	Platform.hs RunAndReadStdout.hs # from src/hmake

CHFILES = $(patsubst %.hs, ../hmake/%.$C, $(OTHERS))


ifeq "${BUILDCOMP}" "ghc"
HFLAGS = $(shell $(LOCAL)fixghc $(GHCSYM) \
      -package lang -package util -package base $(READLINE) )
export HFLAGS
endif
ifeq "${BUILDCOMP}" "hbc"
HFLAGS =
export HFLAGS
endif
ifeq "${BUILDCOMP}" "nhc98"
HFLAGS = -package base
export HFLAGS
endif

all: $(TARGET)
cfiles: cleanC $(SRCS)
	$(HMAKE) -hc=$(LOCAL)nhc98 -I../hmake -C HInteractive.hs
clean: cleanO cleanHi
cleanO:
	-rm -rf *.o $(OBJDIR)
cleanHi:
	-rm -f *.hi
cleanC: clean
	-rm -f *.hc *.c
realclean: clean cleanC
	-rm -f $(OBJDIR)/HInteractive$(EXE)

$(TARGET): $(OBJDIR) $(SRCS)
	$(HMAKE) -hc=$(HC) HInteractive -d$(OBJDIR) \
		$(shell echo "${BUILDOPTS}") -i../hmake $(HFLAGS)
	mv $(OBJDIR)/HInteractive$(EXE) $(TARGET)
	$(STRIP) $(TARGET)

$(OBJDIR):
	mkdir -p $(OBJDIR)

fromC: $(OBJDIR)
	cp $(CHFILES) .
	$(LOCAL)nhc98 -cpp -o $(TARGET) -d$(OBJDIR) *.$C
	rm $(notdir ${CHFILES})
	$(STRIP) $(TARGET)


paper.ps: paper.dvi
	#dvips paper.dvi -O -1.0cm,-2.6cm -o paper.ps
	dvips paper.dvi -o paper.ps
paper.dvi: paper.tex
	latex paper.tex

## hmake 3.13

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 BUILDCOMPS := ghc nhc hbc gcc
 BUILDCOMP1 := $(shell echo $(notdir ${BUILDWITH}) | cut -c1-3)
 BUILDCOMP2 := $(if $(filter $(BUILDCOMP1), $(BUILDCOMPS)),$(BUILDCOMP1),$(shell ${BUILDWITH} 2>&1 | head -1 | cut -c1-3))
-BUILDCOMP := $(if $(filter $(BUILDCOMP2), $(BUILDCOMPS)),$(BUILDCOMP2),$(error Can't find compiler type))
+BUILDCOMP := $(if $(filter $(BUILDCOMP2), $(BUILDCOMPS)),$(BUILDCOMP2),$(error Cannot find compiler type))
 
 
 HMAKE = src/hmake/Makefile* src/hmake/*.hs src/hmake/README* \

=== src/cpphs/Makefile ===
LIBRARY	= cpphs
VERSION	= 1.3

DIRS	= Language/Preprocessor/Cpphs \
	  Text/ParserCombinators

SRCS	= Language/Preprocessor/Cpphs.hs \
          Language/Preprocessor/Cpphs/CppIfdef.hs \
          Language/Preprocessor/Cpphs/HashDefine.hs \
          Language/Preprocessor/Cpphs/MacroPass.hs \
          Language/Preprocessor/Cpphs/Options.hs \
          Language/Preprocessor/Cpphs/Position.hs \
          Language/Preprocessor/Cpphs/ReadFirst.hs \
          Language/Preprocessor/Cpphs/RunCpphs.hs \
          Language/Preprocessor/Cpphs/SymTab.hs \
          Language/Preprocessor/Cpphs/Tokenise.hs \
          Language/Preprocessor/Unlit.hs \
          Text/ParserCombinators/HuttonMeijer.hs \
          cpphs.hs

AUX	= README LICENCE* CHANGELOG $(LIBRARY).cabal Setup.hs Makefile \
	  cpphs.hugs cpphs.compat \
	  tests/[A-BD-Z]* tests/[a-np-z]* \
	  docs/[a-z]*

all: $(LIBRARY)
package:
	tar cf tmp.tar $(SRCS) $(AUX)
	mkdir $(LIBRARY)-$(VERSION)
	cd $(LIBRARY)-$(VERSION); tar xf ../tmp.tar
	tar zcf $(LIBRARY)-$(VERSION).tar.gz $(LIBRARY)-$(VERSION)
	zip -r $(LIBRARY)-$(VERSION).zip $(LIBRARY)-$(VERSION)
	rm -r tmp.tar $(LIBRARY)-$(VERSION)
haddock: $(SRCS)
	mkdir -p docs/$(LIBRARY)
	for dir in $(DIRS); do mkdir -p docs/$(LIBRARY)/$$dir; done
	for file in $(SRCS); \
	    do HsColour -anchorHTML $$file \
	          >docs/$(LIBRARY)/`dirname $$file`/`basename $$file .hs`.html;\
	    done
	haddock --html --title=$(LIBRARY) \
	    --odir=docs/$(LIBRARY) --package=$(LIBRARY) \
	    --source-module="%{MODULE/.//}.html" \
	    --source-entity="%{MODULE/.//}.html#%{NAME}" \
	    $(SRCS)



$(LIBRARY): $(SRCS)
	$(HC) $(HFLAGS) $(HEAP) -o $@  $(SRCS)
	$(STRIP) $@

=== src/hmake/Makefile ===
include Makefile.inc

OBJDIR   = $(BUILDDIR)/$(OBJ)/hmake
CPPHSOBJDIR = $(BUILDDIR)/$(OBJ)/cpphs
MKPROG   = $(DST)/MkProg$(EXE)
OLDER    = $(DST)/Older$(EXE)
MKCONFIG = $(DST)/MkConfig$(EXE)
RUNHS    = $(DST)/runhs$(EXE)
TARGETS  = $(MKPROG) $(OLDER) $(MKCONFIG) $(RUNHS)

SRCS    = QSort.hs Unlit.hs Utils.hs Tsort.hs FileName.hs \
	  Output.hs Order.hs ListUtil.hs Getmodtime.hs \
          MkProg.hs Compiler.hs PreProcessor.hs \
	  PackageConfig.hs RunAndReadStdout.hs Argv.hs
CPPHSSRCS  = \
	  Text/ParserCombinators/HuttonMeijer.hs \
	  Language/Preprocessor/Cpphs/CppIfdef.hs \
	  Language/Preprocessor/Cpphs/Position.hs \
	  Language/Preprocessor/Cpphs/ReadFirst.hs \
	  Language/Preprocessor/Cpphs/Tokenise.hs \
	  Language/Preprocessor/Cpphs/SymTab.hs \
	  Language/Preprocessor/Cpphs/HashDefine.hs
CPPSRCS = Graph.hs GetDep.hs Compat.hs Imports.hs Platform.hs Config.hs
CFGSRCS = RunAndReadStdout.hs Config.hs Compiler.hs Platform.hs
RUNSRCS = runhs.hs
 

OBJS      = $(patsubst %.hs, $(OBJDIR)/%.$O, $(SRCS))
CPPHSOBJS = $(patsubst %.hs, $(CPPHSOBJDIR)/%.$O, $(CPPHSSRCS))
CPPOBJS   = $(patsubst %.hs, $(OBJDIR)/%.$O, $(CPPSRCS))
RAWCPP    = $(patsubst %.hs, %.raw, $(SRCS))
CFGOBJS   = $(patsubst %.hs, $(OBJDIR)/%.$O, $(CFGSRCS))
CFILES    = $(patsubst %.hs, %.$C, $(SRCS))
CPPHSCFILES = $(patsubst %.hs, %.$C, $(patsubst %, ../cpphs/%, $(CPPHSSRCS)))
CPPCFILES = $(patsubst %.hs, %.$C, $(CPPSRCS))
CFGCFILES = $(patsubst %.hs, %.$C, $(CFGSRCS))

AUX     = Makefile* BuildNew* HISTORY README* Summary TODO nhcmakeR cfiles \
          hmake hmake.1

HC = $(LOCAL)nhc98	# can be overridden by caller HC=...
BUILDCOMP = nhc		# override this too if you override HC
HFLAGS = -i../cpphs $(shell echo $(BUILDOPTS)) #-$(CFG)

ifeq "nhc" "$(BUILDCOMP)"
HEAP = -H4M
endif
ifeq "ghc" "$(BUILDCOMP)"
HFLAGS += $(shell ${LOCAL}fixghc ${GHCSYM} -package lang)
endif
ifeq "hbc" "$(BUILDCOMP)"
all: hbc
hbc: CppIfdef.hs
	sed -e 's/System.IO.Unsafe/IOExts/' CppIfdef.hs >hbc
	cp -a hbc CppIfdef.hs
endif


all: $(TARGETS)
config:
	sh $(BUILDDIR)/hmake3.config
cfiles: cleanC $(CFILES) $(CPPCFILES) $(CPPHSCFILES) Older.$C MkConfig.$C runhs.$C
fromC: $(OBJDIR)
	$(HC) $(HFLAGS) -H4M -o $(MKPROG) -d $(OBJDIR) $(CFILES) $(CPPCFILES) \
							$(CPPHSCFILES)
	$(HC) $(HFLAGS)      -o $(OLDER)  -d $(OBJDIR) Older.$C
	$(HC) $(HFLAGS)    -o $(MKCONFIG) -d $(OBJDIR) MkConfig.$C $(CFGCFILES)
	$(HC) $(HFLAGS)      -o $(RUNHS)  -d $(OBJDIR) runhs.$C
	$(STRIP) $(MKPROG) $(OLDER) $(MKCONFIG) $(RUNHS)
clean:
	rm -f $(OBJS) $(CPPOBJS) $(CFGOBJS)
	rm -f $(OBJDIR)/runhs.$O $(OBJDIR)/Older.$O $(OBJDIR)/MkConfig.$O
	rm -f *.hi
cleanC: clean
	rm -f *.hc *.c
realclean: cleanC
	rm -f *.raw *.html haddock.css haskell_icon.gif
	rm -f $(TARGETS)
#package:
#	tar zcvf hmake.tar.gz $(SRCS) $(GCSRCS) $(CPPSRCS) Older.hs MkConfig.hs $(AUX)
haddock: $(RAWCPP)
	haddock -h *.raw
	rm *.raw


$(MKPROG): $(OBJDIR) $(CPPHSOBJDIR) $(OBJS) $(CPPOBJS) $(CPPHSOBJS)
	$(HC) $(HFLAGS) $(HEAP) -o $@  $(OBJS) $(CPPOBJS) $(CPPHSOBJS)
	$(STRIP) $@
$(OLDER): $(OBJDIR) $(OBJDIR)/Older.$O
	$(HC) $(HFLAGS) -o $@  $(OBJDIR)/Older.$O
	$(STRIP) $@
$(MKCONFIG): $(OBJDIR) $(OBJDIR)/MkConfig.$O $(CFGOBJS)
	$(HC) $(HFLAGS) -o $@  $(OBJDIR)/MkConfig.$O $(CFGOBJS)
	$(STRIP) $@
$(RUNHS): $(OBJDIR) $(OBJDIR)/runhs.$O
	$(HC) $(HFLAGS) -o $@ $(OBJDIR)/runhs.$O

%.raw:
	cpp -P -traditional $(patsubst %.raw, %.hs, $@) > $@

$(OBJDIR):
	mkdir -p $@ || $(TRUE)
$(CPPHSOBJDIR):
	mkdir -p $@ || $(TRUE)
	mkdir -p $@/Text/ParserCombinators || $(TRUE)
	mkdir -p $@/Language/Preprocessor/Cpphs || $(TRUE)
$(OBJS) : $(OBJDIR)/%.$O : %.hs
	$(HC) $(HFLAGS) -c -o $@ $<
$(CPPHSOBJS) : $(CPPHSOBJDIR)/%.$O : ../cpphs/%.hs
	$(HC) $(HFLAGS) -c -o $@ $<
$(CPPOBJS) $(OBJDIR)/Older.$O $(OBJDIR)/MkConfig.$O $(OBJDIR)/runhs.$O : $(OBJDIR)/%.$O : %.hs
	$(HC) $(HFLAGS) -c -cpp -o $@ $<

$(CFILES) : %.$C : %.hs
	$(HC) $(HFLAGS) -C $<
$(CPPCFILES) Older.$C MkConfig.$C runhs.$C : %.$C : %.hs
	$(HC) $(HFLAGS) -C -cpp $<
$(CPPHSCFILES) : %.$C : %.hs
	$(HC) $(HFLAGS) -C $<

# dependencies generated by hmake -Md:
${OBJDIR}/Output.$O:	${OBJDIR}/ListUtil.$O ${OBJDIR}/FileName.$O \
			${OBJDIR}/Argv.$O ${OBJDIR}/PreProcessor.$O \
			${OBJDIR}/Config.$O ${OBJDIR}/RunAndReadStdout.$O
${OBJDIR}/Utils.$O:	${OBJDIR}/Compat.$O ${OBJDIR}/ListUtil.$O 
${OBJDIR}/Tsort.$O:	${OBJDIR}/Compat.$O 
${OBJDIR}/Graph.$O:	${OBJDIR}/Compat.$O ${OBJDIR}/ListUtil.$O 
${OBJDIR}/QSort.$O:	
${OBJDIR}/Compat.$O:	${OBJDIR}/ListUtil.$O ${OBJDIR}/QSort.$O 
${OBJDIR}/Order.$O:	${OBJDIR}/Compat.$O ${OBJDIR}/Graph.$O \
			${OBJDIR}/ListUtil.$O ${OBJDIR}/Tsort.$O \
			${OBJDIR}/Utils.$O 
${OBJDIR}/PreProcessor.$O: ${OBJDIR}/Argv.$O ${OBJDIR}/Compiler.$O \
			${OBJDIR}/Config.$O ${OBJDIR}/Unlit.$O 
${OBJDIR}/Unlit.$O:	
${OBJDIR}/FileName.$O:	${OBJDIR}/Argv.$O 
${OBJDIR}/Imports.$O:	${OBJDIR}/ListUtil.$O \
			${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/CppIfdef.$O
${OBJDIR}/Getmodtime.$O: 
${OBJDIR}/GetDep.$O:	${OBJDIR}/Getmodtime.$O ${OBJDIR}/Imports.$O \
			${OBJDIR}/FileName.$O ${OBJDIR}/Unlit.$O \
			${OBJDIR}/Argv.$O ${OBJDIR}/PreProcessor.$O \
			${OBJDIR}/Config.$O 
${OBJDIR}/RunAndReadStdout.$O:	${OBJDIR}/Platform.$O
${OBJDIR}/PackageConfig.$O:	${OBJDIR}/Config.$O ${OBJDIR}/Compiler.$O \
			${OBJDIR}/Platform.$O ${OBJDIR}/RunAndReadStdout.$O 
${OBJDIR}/Platform.$O:	
${OBJDIR}/Config.$O:	${OBJDIR}/Compiler.$O ${OBJDIR}/Platform.$O \
			${OBJDIR}/RunAndReadStdout.$O 
${OBJDIR}/Compiler.$O:	
${OBJDIR}/ListUtil.$O:	
${OBJDIR}/Argv.$O:	${OBJDIR}/ListUtil.$O ${OBJDIR}/Compiler.$O \
			${OBJDIR}/Config.$O ${OBJDIR}/PackageConfig.$O \
			${OBJDIR}/Platform.$O
${OBJDIR}/MkProg.$O:	${OBJDIR}/Argv.$O ${OBJDIR}/GetDep.$O \
			${OBJDIR}/Getmodtime.$O ${OBJDIR}/ListUtil.$O \
			${OBJDIR}/Order.$O ${OBJDIR}/Output.$O 
${OBJDIR}/MkConfig.$O:	${OBJDIR}/Compiler.$O ${OBJDIR}/Config.$O
${OBJDIR}/Older.$O:	

${CPPHSOBJDIR}/Text/ParserCombinators/HuttonMeijer.$O:	
${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/HashDefine.$O:
${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Tokenise.$O:	\
		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/HashDefine.$O
${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/ReadFirst.$O: \
		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Position.$O \
		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/SymTab.$O
${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Position.$O:	
${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/SymTab.$O:	
${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/CppIfdef.$O:	\
		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/SymTab.$O \
		${CPPHSOBJDIR}/Text/ParserCombinators/HuttonMeijer.$O \
		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Position.$O \
		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/ReadFirst.$O \
		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Tokenise.$O



# C-files dependencies.
MkConfig.$C: Compiler.$C Config.$C
Output.$C: ListUtil.$C FileName.$C Argv.$C PreProcessor.$C Config.$C \
	RunAndReadStdout.$C 
Utils.$C: Compat.$C ListUtil.$C 
Tsort.$C: Compat.$C 
Graph.$C: Compat.$C ListUtil.$C 
QSort.$C: 
Compat.$C: ListUtil.$C QSort.$C 
Order.$C: Compat.$C Graph.$C ListUtil.$C Tsort.$C Utils.$C 
PreProcessor.$C: Argv.$C Compiler.$C Config.$C Unlit.$C 
Unlit.$C: 
FileName.$C: Argv.$C 
Imports.$C: ListUtil.$C ../cpphs/Language/Preprocessor/Cpphs/CppIfdef.$C 
Getmodtime.$C: 
GetDep.$C: Getmodtime.$C Imports.$C FileName.$C Unlit.$C Argv.$C \
	PreProcessor.$C Config.$C 
RunAndReadStdout.$C: Platform.$C 
PackageConfig.$C: Config.$C Compiler.$C Platform.$C RunAndReadStdout.$C 
Platform.$C: 
Config.$C: Compiler.$C Platform.$C RunAndReadStdout.$C
Compiler.$C: 
ListUtil.$C: 
Argv.$C: ListUtil.$C Compiler.$C Config.$C PackageConfig.$C Platform.$C 
MkProg.$C: Argv.$C GetDep.$C Getmodtime.$C ListUtil.$C Order.$C Output.$C 

../cpphs/Language/Preprocessor/Cpphs/HashDefine.$C: 
../cpphs/Language/Preprocessor/Cpphs/Tokenise.$C: \
		../cpphs/Language/Preprocessor/Cpphs/HashDefine.$C 
../cpphs/Language/Preprocessor/Cpphs/ReadFirst.$C: \
		../cpphs/Language/Preprocessor/Cpphs/Position.$C \
		../cpphs/Language/Preprocessor/Cpphs/SymTab.$C 
../cpphs/Language/Preprocessor/Cpphs/Position.$C: 
../cpphs/Text/ParserCombinators/HuttonMeijer.$C: 
../cpphs/Language/Preprocessor/Cpphs/SymTab.$C: 
../cpphs/Language/Preprocessor/Cpphs/CppIfdef.$C: \
		../cpphs/Language/Preprocessor/Cpphs/SymTab.$C \
		../cpphs/Text/ParserCombinators/HuttonMeijer.$C \
		../cpphs/Language/Preprocessor/Cpphs/Position.$C \
		../cpphs/Language/Preprocessor/Cpphs/ReadFirst.$C \
		../cpphs/Language/Preprocessor/Cpphs/Tokenise.$C

## hmake 3.14

=== src/cpphs/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 LIBRARY	= cpphs
-VERSION	= 1.3
+VERSION	= 1.5
 
 DIRS	= Language/Preprocessor/Cpphs \
 	  Text/ParserCombinators
@@ -48,4 +48,4 @@
 
 $(LIBRARY): $(SRCS)
 	$(HC) $(HFLAGS) $(HEAP) -o $@  $(SRCS)
-	$(STRIP) $@
+	$(HOSTSTRIP) $@

=== src/hmake/Makefile ===
--- 
+++ 
@@ -19,7 +19,9 @@
 	  Language/Preprocessor/Cpphs/ReadFirst.hs \
 	  Language/Preprocessor/Cpphs/Tokenise.hs \
 	  Language/Preprocessor/Cpphs/SymTab.hs \
-	  Language/Preprocessor/Cpphs/HashDefine.hs
+	  Language/Preprocessor/Cpphs/HashDefine.hs \
+	  Language/Preprocessor/Cpphs/MacroPass.hs \
+	  Language/Preprocessor/Cpphs/Options.hs
 CPPSRCS = Graph.hs GetDep.hs Compat.hs Imports.hs Platform.hs Config.hs
 CFGSRCS = RunAndReadStdout.hs Config.hs Compiler.hs Platform.hs
 RUNSRCS = runhs.hs
@@ -66,7 +68,7 @@
 	$(HC) $(HFLAGS)      -o $(OLDER)  -d $(OBJDIR) Older.$C
 	$(HC) $(HFLAGS)    -o $(MKCONFIG) -d $(OBJDIR) MkConfig.$C $(CFGCFILES)
 	$(HC) $(HFLAGS)      -o $(RUNHS)  -d $(OBJDIR) runhs.$C
-	$(STRIP) $(MKPROG) $(OLDER) $(MKCONFIG) $(RUNHS)
+	$(HOSTSTRIP) $(MKPROG) $(OLDER) $(MKCONFIG) $(RUNHS)
 clean:
 	rm -f $(OBJS) $(CPPOBJS) $(CFGOBJS)
 	rm -f $(OBJDIR)/runhs.$O $(OBJDIR)/Older.$O $(OBJDIR)/MkConfig.$O
@@ -85,13 +87,13 @@
 
 $(MKPROG): $(OBJDIR) $(CPPHSOBJDIR) $(OBJS) $(CPPOBJS) $(CPPHSOBJS)
 	$(HC) $(HFLAGS) $(HEAP) -o $@  $(OBJS) $(CPPOBJS) $(CPPHSOBJS)
-	$(STRIP) $@
+	$(HOSTSTRIP) $@
 $(OLDER): $(OBJDIR) $(OBJDIR)/Older.$O
 	$(HC) $(HFLAGS) -o $@  $(OBJDIR)/Older.$O
-	$(STRIP) $@
+	$(HOSTSTRIP) $@
 $(MKCONFIG): $(OBJDIR) $(OBJDIR)/MkConfig.$O $(CFGOBJS)
 	$(HC) $(HFLAGS) -o $@  $(OBJDIR)/MkConfig.$O $(CFGOBJS)
-	$(STRIP) $@
+	$(HOSTSTRIP) $@
 $(RUNHS): $(OBJDIR) $(OBJDIR)/runhs.$O
 	$(HC) $(HFLAGS) -o $@ $(OBJDIR)/runhs.$O
 
@@ -161,10 +163,10 @@
 ${CPPHSOBJDIR}/Text/ParserCombinators/HuttonMeijer.$O:	
 ${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/HashDefine.$O:
 ${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Tokenise.$O:	\
-		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/HashDefine.$O
+		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/HashDefine.$O \
+		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Position.$O
 ${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/ReadFirst.$O: \
-		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Position.$O \
-		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/SymTab.$O
+		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Position.$O
 ${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Position.$O:	
 ${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/SymTab.$O:	
 ${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/CppIfdef.$O:	\
@@ -172,7 +174,10 @@
 		${CPPHSOBJDIR}/Text/ParserCombinators/HuttonMeijer.$O \
 		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Position.$O \
 		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/ReadFirst.$O \
-		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Tokenise.$O
+		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Tokenise.$O \
+		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/Options.$O \
+		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/HashDefine.$O \
+		${CPPHSOBJDIR}/Language/Preprocessor/Cpphs/MacroPass.$O
 
 
 
@@ -204,10 +209,10 @@
 
 ../cpphs/Language/Preprocessor/Cpphs/HashDefine.$C: 
 ../cpphs/Language/Preprocessor/Cpphs/Tokenise.$C: \
-		../cpphs/Language/Preprocessor/Cpphs/HashDefine.$C 
+		../cpphs/Language/Preprocessor/Cpphs/HashDefine.$C \
+		../cpphs/Language/Preprocessor/Cpphs/Position.$C 
 ../cpphs/Language/Preprocessor/Cpphs/ReadFirst.$C: \
-		../cpphs/Language/Preprocessor/Cpphs/Position.$C \
-		../cpphs/Language/Preprocessor/Cpphs/SymTab.$C 
+		../cpphs/Language/Preprocessor/Cpphs/Position.$C
 ../cpphs/Language/Preprocessor/Cpphs/Position.$C: 
 ../cpphs/Text/ParserCombinators/HuttonMeijer.$C: 
 ../cpphs/Language/Preprocessor/Cpphs/SymTab.$C: 
@@ -216,4 +221,7 @@
 		../cpphs/Text/ParserCombinators/HuttonMeijer.$C \
 		../cpphs/Language/Preprocessor/Cpphs/Position.$C \
 		../cpphs/Language/Preprocessor/Cpphs/ReadFirst.$C \
-		../cpphs/Language/Preprocessor/Cpphs/Tokenise.$C 
+		../cpphs/Language/Preprocessor/Cpphs/Tokenise.$C \
+		../cpphs/Language/Preprocessor/Cpphs/Options.$C \
+		../cpphs/Language/Preprocessor/Cpphs/HashDefine.$C \
+		../cpphs/Language/Preprocessor/Cpphs/MacroPass.$C

=== src/interpreter/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 ifeq "${BUILDCOMP}" "ghc"
 HFLAGS = $(shell $(LOCAL)fixghc $(GHCSYM) \
-      -package lang -package util -package base $(READLINE) )
+      -package lang -package util -package base -package readline $(READLINE) )
 export HFLAGS
 endif
 ifeq "${BUILDCOMP}" "hbc"
@@ -40,7 +40,7 @@
 	$(HMAKE) -hc=$(HC) HInteractive -d$(OBJDIR) \
 		$(shell echo "${BUILDOPTS}") -i../hmake $(HFLAGS)
 	mv $(OBJDIR)/HInteractive$(EXE) $(TARGET)
-	$(STRIP) $(TARGET)
+	$(HOSTSTRIP) $(TARGET)
 
 $(OBJDIR):
 	mkdir -p $(OBJDIR)
@@ -49,7 +49,7 @@
 	cp $(CHFILES) .
 	$(LOCAL)nhc98 -cpp -o $(TARGET) -d$(OBJDIR) *.$C
 	rm $(notdir ${CHFILES})
-	$(STRIP) $(TARGET)
+	$(HOSTSTRIP) $(TARGET)
 
 
 paper.ps: paper.dvi

=== debian/changelog ===
hmake (3.14-3) unstable; urgency=low

  [ Joachim Breitner ]
  * Section: haskell

  [ Marco Silva ]
  * Use ghc instead of ghc6

  [ Joachim Breitner ]
  * Fix FTBFS: Compat.hs:47:55: Not in scope: `isAlphanum' (Closes: #628308)

 -- Joachim Breitner <nomeata@debian.org>  Thu, 02 Jun 2011 20:24:46 +0200

hmake (3.14-2) unstable; urgency=low

  * Added libghc6-editline-dev dependency 
  * Bump standards version

 -- Joachim Breitner <nomeata@debian.org>  Fri, 05 Feb 2010 19:47:53 +0100

hmake (3.14-1) unstable; urgency=low

  * New upstream relase
  * Switch to 3.0 (quilt) source format
  * Adopt for the Debian Haskell Team
  * Redo Packaging using dh (Closes: #536925, #403842)
  * Steal patches from
    http://www.freebsd.org/cgi/cvsweb.cgi/ports/devel/hs-hmake/
  * Resurrect Ian’s "machine type debian" patch 
  * patches/no-package-lang.patch: Do not pass -package lang to ghc6

 -- Joachim Breitner <nomeata@debian.org>  Fri, 05 Feb 2010 17:07:46 +0100

hmake (3.13-0.1) unstable; urgency=high

  * Non-maintainer upload.
  * Set urgency to high as this upload fixes an RC bug.
  * New upstream release:
    * Dropped patch to script/fixghc (applied upstream).
    * Dropped patch to src/interpreter/Makefile (applied upstream).
    * src/interpreter/SimpleLineEditor.hs (applied upstream).
  * scripts/confhc:
    * Filter out LINE pragma when determining the version number of
      GHC. (Closes: #427311)
  * src/hmake/{Config.hs,PackageConfig.hs}:
    * Update the program to search for the imports in another directory
      if the GHC version >= 6.8 as of that version they are shipped in
      $ghclibdir/lib/$package instead of $ghclibdir/imports 
      (Closes: #459737) 
  
 -- Arjan Oosting <arjan@debian.org>  Sat, 16 Feb 2008 23:02:48 +0100

hmake (3.12-1) unstable; urgency=low

  * New upstream version:
    * Builds with GHC 6.6. Closes: #393582.
    * Dropped patch to src/interpreter/HInteractive.hs (unnecessary
      now cpp is not used on that file).
    * Dropped patch to script/confhc (upstream applied an alternate fix).
    * Dropped patch to src/hmake/PackageConfig.hs (upstream applied an
      alternate fix).
    * Dropped patch to src/interpreter/Makefile (applied upstream).
    * Dropped patch to man/hmake.1 (applied upstream).
    * Dropped patch to Makefile (applied upstream).
  * make realclean rather than merely clean.
  * Added hacks to clean .hi files that get left behind.
  * Drop README that just pointed at the upstream website.
  * Updated debian/control so the new GHC arches get included.
  * Apply:
      Malcolm.Wallace@cs.york.ac.uk**20061030104744
      module Readline is now called System.Console.Readline,
      and it lives in -package readline instead of -package util (or wherever
      it used to be).
    (affects script/fixghc, src/interpreter/Makefile and
     src/interpreter/SimpleLineEditor.hs).

 -- Ian Lynagh (wibble) <igloo@debian.org>  Sat, 28 Oct 2006 21:22:32 +0000

hmake (3.10-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Applied patches from Stefan Potyra to fix bug reported by Daniel
    Schepler to adapt to output changes in new ghc6 version that make
    "__GLASGOW_HASKELL__" be expanded into many lines instead of one.
    scripts/confhc uses the output to create lib/debian/config, and
    makes assumptions about the format. Similarly for 
    src/interpreter/HInteractive.hs. Closes: #335842.

 -- Lars Wirzenius <liw@iki.fi>  Fri,  6 Jan 2006 19:30:00 +0200

hmake (3.10-1) unstable; urgency=low

  * New upstream version. Closes: #309837.
  * Remove $nhc98_app_bdeps option from build-deps as nhc98 is being
    removed from Debian.
  * Escape ${shlibs:Depends} in debian/control.in for
    update-haskell-control.
  * Bump standards version to 3.6.2.
  * Run update-haskell-control.
  * Set DEBIAN env var when configuring so the dynamic compilers are
    added to the config rather than the installed static ones.
  * Built against new libgmp3-dev. Closes: #329912.
  * Use \[:o] in the hmake manpage rather than the actual character from
    some charset.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Wed, 05 Oct 2005 21:57:56 +0000

hmake (3.09-3) unstable; urgency=low

  * Have in-tree harch just "echo debian".
  * Set MACHINE to debian rather than calling harch in /usr/bin/*.
    Closes: #300620.
  * Remove /usr/bin/harch (and it's manpage) as it is no longer needed.
  * Update build-deps to reflect nhc98 not being available for m68k or sparc.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Sat, 26 Mar 2005 11:06:59 +0000

hmake (3.09-2) unstable; urgency=low

  * Look in the base package when compiling with nhc98 1.16.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Fri, 28 Jan 2005 20:47:32 +0000

hmake (3.09-1) unstable; urgency=low

  * Updated debian/copyright.
  * Use `dpkg-architecture -qDEB_HOST_ARCH`-`uname` to create harch.
    Fixes problems where the existing implementation doesn't know some
    names need to be unified.
  * Use update-haskell-control to generate debian/control from a control.in.
    Use vars for the compiler info. Closes: #253218.
  * Call update-haskell-control --check in debian/rules.
  * Policy version bumped to 3.6.1 (no other changes necessary).
  * Removed debian/hmake.undocumented as we don't even call dh_undocumented
    any more.
  * Remove debian/hi.1 when making clean.
  * Fix type (srcipt -> script) in debian/in-rules.
  * Made watch file

 -- Ian Lynagh (wibble) <igloo@debian.org>  Thu, 18 Nov 2004 17:04:56 +0000

hmake (3.08-7) unstable; urgency=low

  * Add m68k to the list of arches that can use ghc6 as a build-dep.
  * Require ghc6 >= 6.2.1-1 to avoid the static linking in earlier
    versions on some arches.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Sun, 25 Apr 2004 21:07:31 +0000

hmake (3.08-6) unstable; urgency=low

  * Use runAndReadStdout to find out what a compiler is rather than
    playing games with return statuses. Works around an nhc98 bug
    in reporting process exit statuses.



=== debian/control ===
Source: hmake
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>
Standards-Version: 3.8.4
Build-Depends:
	ghc,
	sharutils,
	cdbs,
	debhelper (>= 7.0.50~),
	libncurses5-dev,
	libghc-editline-dev

Package: hmake
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ghc 
Description: The Haskell Make System
 This package contains a universal make system for use with
 Haskell compilers.  hmake is not compiler-dependent, so you
 may use this with hugs, ghc, or nhc98.
 .
 hmake will use the module import definitions of the source
 files to determine which modules need to be compiled and
 loaded to run the resulting executable.
 .
 In addition, the "hi" hmake-interactive environment is provided.
 This is a hugs-like text-mode utility that allows you to
 interactively program using any of the available Haskell
 compilers (including ghc, but defaults to nhc98.)  WARNING:  This
 is a fairly slow interpreter :-)
 .
 For more information, see the nhc98 web page at
 <http://www.cs.york.ac.uk/fp/nhc98/>.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	./configure --prefix=/usr \
	            --mandir=/usr/share/man/man1 \
	            --confdir=/var/lib/hmake 

override_dh_auto_build:
	$(MAKE) all
	$(MAKE) -f debian/in-rules debian/hi.1

override_dh_auto_install: 
	$(MAKE) DESTDIR=$(CURDIR)/debian/hmake install
	rm -f debian/hmake/usr/bin/harch
	for i in debian/hmake/usr/bin/*; \
	    do  mv "$$i" "$$i.old"; \
	        sed "s/^MACHINE=.*/MACHINE=debian/" < "$$i.old" > "$$i"; \
	        chmod --reference="$$i.old" "$$i"; \
	        rm "$$i.old"; \
	    done

	mkdir -p $(CURDIR)/debian/hmake/usr/share/doc/hmake/html
	cp docs/hmake/*.* $(CURDIR)/debian/hmake/usr/share/doc/hmake/html

override_dh_clean:
	-$(MAKE) realclean
	rm -rf lib targets
	rm -f debian/hi.1
	# Hacks:
	rm -f src/cpphs/Language/Preprocessor/Cpphs/*.hi
	rm -f src/cpphs/Text/ParserCombinators/*.hi
	rm -f ghcsym.o ghcsym.hi
	rm -f scripts/hi scripts/hmake scripts/hmake-config

	dh_clean

=== debian/watch ===
# IGNORE: hmake webpage has vanished
# version=2
# http://www.haskell.org/hmake/ (?:.*/)?hmake-(.*)\.tar\.gz
